<template>
  <q-layout-drawer
    side="left"
    v-model="isSidebarActive"
    :content-class="$q.theme === 'mat' ? 'bg-grey-3' : null"
  >
    <q-scroll-area class="fit">
      <q-list-header>{{$t('sidebar.menu.main')}}</q-list-header>
      <q-item to="/">
        <q-item-side icon="home"/>
        <q-item-main
          :label="$t('sidebar.menu.items.main.dashboard')"
        />
      </q-item>
      <q-list-header>{{$t('sidebar.menu.menu')}}</q-list-header>
      <q-item
        v-for="({path, label}) in menuItems"
        :key="path"
        :to="`/report${path}`"
      >
        {{label}}
      </q-item>
    </q-scroll-area>
  </q-layout-drawer>
</template>

<script>

import apiMixin from '../../utilities/apiMixin'

export default {
  name: 'SidebarComponent',
  computed: {
    isSidebarActive: {
      get() { return this.$store.state.layout.isSidebarActive },
      set(val) { this.$store.commit('layout/isSidebarActive', val) },
    },
  },
  data() {
    return {
      menuItems: [],
    }
  },
  mixins: [apiMixin],
  created() {
    this.$axios.get(this.getApiUrl('swagger.json'))
      .then(({ data: { paths } }) => {
        Object.entries(paths).forEach(([path, { get }]) => {
          if (get) {
            this.menuItems.push({
              path,
              label: get.operationId,
            })
          }
        })
      })
  },
}
</script>
